/*
 * Copyright (c) IntellectualCrafters - 2014. You are not allowed to distribute
 * and/or monetize any of our intellectual property. IntellectualCrafters is not
 * affiliated with Mojang AB. Minecraft is a trademark of Mojang AB.
 *
 * >> File = Lag.java >> Generated by: Citymonstret at 2014-08-09 01:43
 */

package com.intellectualcrafters.plot;

/**
 * TPS and Lag Checker.
 *
 * @author Citymonstret
 */
public class Lag implements Runnable {

    /**
     * Tick count
     */
    public static int    TC = 0;
    /**
     * Ticks
     */
    public static long[] T  = new long[600];
    /**
     * something :_:
     */
    @SuppressWarnings("unused")
    public static long   LT = 0L;

    /**
     * Get the server TPS
     *
     * @return server tick per second
     */
    public static double getTPS() {
        return Math.round(getTPS(100)) > 20.0D ? 20.0D : Math.round(getTPS(100));
    }

    /**
     * Return the tick per second (measured in $ticks)
     *
     * @param ticks
     *            Ticks
     * @return ticks per second
     */
    public static double getTPS(final int ticks) {
        if (TC < ticks) {
            return 20.0D;
        }
        final int t = (TC - 1 - ticks) % T.length;
        final long e = System.currentTimeMillis() - T[t];
        return ticks / (e / 1000.0D);
    }

    /**
     * Get number of ticks since
     *
     * @param tI
     *            Ticks <
     * @return number of ticks since $tI
     */
    @SuppressWarnings("unused")
    public static long getElapsed(final int tI) {
        final long t = T[tI % T.length];
        return System.currentTimeMillis() - t;
    }

    @Override
    public void run() {
        T[TC % T.length] = System.currentTimeMillis();
        TC++;
    }

    /**
     * Get lag percentage
     *
     * @return lag percentage
     */
    public static double getPercentage() {
        return Math.round((1.0D - (Lag.getTPS() / 20.0D)) * 100.0D);
    }

    /**
     * Get TPS percentage (of 20)
     *
     * @return TPS percentage
     */
    public static double getFullPercentage() {
        return getTPS() * 5.0D;
    }
}
